# javascript-problems-and-solutions

[![npm version](https://badge.fury.io/js/javascript-problems-and-solutions.svg)](https://badge.fury.io/js/javascript-problems-and-solutions)
[![Build Status](https://travis-ci.org/jeantimex/javascript-problems-and-solutions.svg?branch=master)](https://travis-ci.org/jeantimex/javascript-problems-and-solutions)
[![Coverage Status](https://coveralls.io/repos/github/jeantimex/javascript-problems-and-solutions/badge.svg?branch=code-coverage)](https://coveralls.io/github/jeantimex/javascript-problems-and-solutions?branch=code-coverage)
[![devDependencies Status](https://david-dm.org/jeantimex/javascript-problems-and-solutions/dev-status.svg)](https://david-dm.org/jeantimex/javascript-problems-and-solutions?type=dev)

A collection of JavaScript problems and solutions for studying algorithms.

![cover](docs/images/cover.png)

## Problems

### Tree

- [Binary Tree Inorder Traversal](src/tree/binary-tree-inorder-traversal.js)
- [Unique Binary Search Trees](src/tree/unique-binary-search-trees.js)
- [Unique Binary Search Trees II](src/tree/unique-binary-search-trees-ii.js)
- [Validate Binary Search Tree](src/tree/validate-binary-search-tree.js)
- [Recover Binary Search Tree](src/tree/recover-binary-search-tree.js)
- [Same Tree](src/tree/same-tree.js)
- [Symmetric Tree](src/tree/symmetric-tree.js)
- [Binary Tree Level Order Traversal](src/tree/binary-tree-level-order-traversal.js)
- [Binary Tree Zigzag Level Order Traversal](src/tree/binary-tree-zigzag-level-order-traversal.js)
- [Maximum Depth of Binary Tree](src/tree/maximum-depth-of-binary-tree.js)
- [Construct Binary Tree From Preorder and Inorder Traversal](src/tree/construct-binary-tree-from-preorder-and-inorder-traversal.js)
- [Construct Binary Tree From Postorder and Inorder Traversal](src/tree/construct-binary-tree-from-inorder-and-postorder-traversal.js)
- [Convert Sorted Array to Binary Search Tree](src/tree/convert-sorted-array-to-binary-search-tree.js)
- [Balanced Binary Tree](src/tree/balanced-binary-tree.js)
- [Minimum Depth of Binary Tree](src/tree/minimum-depth-of-binary-tree.js)
- [Path Sum](src/tree/path-sum.js)
- [Path Sum II](src/tree/path-sum-ii.js)
- [Flatten Binary Tree to Linked List](src/tree/flatten-binary-tree-to-linked-list.js)
- [Populating Next Right Pointers in Each Node](src/tree/populating-next-right-pointers-in-each-node.js)
- [Populating Next Right Pointers in Each Node II](src/tree/populating-next-right-pointers-in-each-node-ii.js)
- [Binary Tree Maximum Path Sum](src/tree/binary-tree-maximum-path-sum.js)
- [Sum Root to Leaf Numbers](src/tree/sum-root-to-leaf-numbers.js)
- [Binary Tree Preorder Traversal](src/tree/binary-tree-preorder-traversal.js)
- [Binary Tree Postorder Traversal](src/tree/binary-tree-postorder-traversal.js)
- [Binary Tree Upside Down](src/tree/binary-tree-upside-down.js)
- [Univalue Tree](src/tree/univalue-tree.js)
- [Count Univalue Subtrees](src/tree/count-univalue-subtrees.js)

### Dynamic Programming

- [Longest Increasing Subsequence](src/dynamic-programming/longest-increasing-subsequence.js)

## LICENSE

MIT License

Copyright (c) 2017 Yong Su @jeantimex

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
